import babelTemplate from 'babel-template';
import Util from '../util';

const originalTemplate = babelTemplate(`
  var TEMPLATE_NAME = props => {
    return CHILDREN;
  };
`);

const templateSyntax = (types, nodePath) => {
  const children = Util.getChildren(nodePath);
  const attributes = Util.getAttributes(nodePath);
  const divElement = Util.createElement(types, children, attributes);

  let templateName = Util.getAttribute(nodePath, 'name');

  if (!templateName) {
    throw new SyntaxError('template attribute not found: name');
  }

  templateName = templateName.value.value;

  const syntax = originalTemplate({
    TEMPLATE_NAME: types.Identifier(templateName),
    CHILDREN: divElement,
  });

  return syntax;
};

export default templateSyntax;